VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBoard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Denne klassen representerer et lottobrett samt retteklassen

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Definerer et tall
Private Type Number
    Data As Long
    extra As Long
End Type

' En array som inneholder alle tallene
Private aNumbers() As Number

' Den totale mengden tall i dette brett
Public NumberCount As Long

Public Property Get Numbers(ByVal Index As Long) As Long

    ' Returner verdien til det angitte nummeret
    If IsNumber(Index) Then
        Numbers = aNumbers(Index).Data
    End If

End Property

Public Property Let Numbers(ByVal Index As Long, ByVal vNewValue As Long)

    ' Sett nummerets verdi
    If IsNumber(Index) Then
        aNumbers(Index).Data = vNewValue
    End If

End Property

Public Property Get extra(ByVal Index As Long) As Long

    ' Returner verdien til det angitte nummeret
    If IsNumber(Index) Then
        extra = aNumbers(Index).extra
    End If

End Property

Public Property Let extra(ByVal Index As Long, ByVal vNewValue As Long)

    ' Sett nummerets verdi
    If IsNumber(Index) Then
        aNumbers(Index).extra = vNewValue
    End If

End Property

Public Function IsNumber(ByVal Index As Long) As Boolean
    
    ' Returnerer hvorvidt tallet eksisterer
    IsNumber = CBool(Index >= 0 And Index <= NumberCount)

End Function

Public Sub AllocateNumbers(ByVal Count As Long)

    Dim Tell As Long

    ' Initialize array
    ReDim aNumbers(Count)
    
    ' Set default values
    For Tell = 0 To Count
        aNumbers(Tell).extra = vbWhite
    Next
    
    ' Set the count
    NumberCount = Count
    
End Sub

' Legger til et tall
Public Sub AppendNumber(ByVal Value As Long, ByVal extra As Long)

    ' k tallteller
    NumberCount = NumberCount + 1
    
    ' Forstrr array slik at vi fr plass til det nye tallet
    ReDim Preserve aNumbers(NumberCount)
    
    ' Sett elementets verdier
    With aNumbers(NumberCount)
        .Data = Value
        .extra = extra
    End With

End Sub

' Fjerner et tall (er i bunn og grunn ikke i bruk)
Public Sub RemoveNumber(ByVal Index As Long)

    Dim Tell As Long
    
    ' Frst, flytt alle elementer ovenfor elementet vi skal slette et steg nedover
    For Tell = Index To NumberCount - 1
        LSet aNumbers(Tell) = aNumbers(Tell + 1)
    Next

    ' Deretter senker vi antall elementer i tallteller
    NumberCount = NumberCount - 1
    
    ' Samt array
    If NumberCount < 0 Then
        ClearAll
    Else
        ReDim Preserve aNumbers(NumberCount)
    End If

End Sub

Public Function FindNumber(ByVal Value As Long, Optional StartLoc As Long = 0, Optional EndLoc As Long = -1)

    Dim Tell As Long

    ' Use the last element if the end location isn't defined
    If EndLoc < 0 Or EndLoc > NumberCount Then
        EndLoc = NumberCount
    End If

    ' Attempt to find the given value
    For Tell = StartLoc To EndLoc
    
        ' See whether or not the value corrresponds
        If Value = aNumbers(Tell).Data Then
            
            ' Return its index
            FindNumber = Tell
            
            ' We're done
            Exit Function
        
        End If
    
    Next
    
    ' Nothing found
    FindNumber = -1

End Function

Public Sub FileLoad(FileHandle As Long)

    ' Firstly, retrieve the lenght of the array
    Get #FileHandle, , NumberCount
    
    ' Initialize the array
    ReDim aNumbers(NumberCount)
    
    ' Load the array
    Get #FileHandle, , aNumbers

End Sub

Public Sub FileSave(FileHandle As Long)

    ' Save the lenght of the array, ...
    Put #FileHandle, , NumberCount
    
    ' As well as the the array itself
    Put #FileHandle, , aNumbers

End Sub

Private Sub Class_Initialize()

    ' La oss initialisere array og tallteller
    ClearAll

End Sub

Public Sub ClearAll()

    ' Frst - slett arrayen med alle dens verdier
    Erase aNumbers
    
    ' Dernest, tilbakestill tallteller
    NumberCount = -1

End Sub
