VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Extra"
   ClientHeight    =   7410
   ClientLeft      =   165
   ClientTop       =   765
   ClientWidth     =   8520
   LinkTopic       =   "Form1"
   ScaleHeight     =   494
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   568
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picContainer 
      Height          =   6375
      Left            =   120
      ScaleHeight     =   421
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   549
      TabIndex        =   0
      Top             =   120
      Width           =   8295
      Begin VB.VScrollBar vScroll 
         Height          =   6255
         Left            =   7965
         TabIndex        =   2
         Top             =   0
         Visible         =   0   'False
         Width           =   255
      End
      Begin pExtra.usrBoard usrBoard 
         Height          =   3135
         Index           =   0
         Left            =   120
         TabIndex        =   1
         Top             =   120
         Visible         =   0   'False
         Width           =   2655
         _ExtentX        =   4683
         _ExtentY        =   5530
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save as"
      End
      Begin VB.Menu mnuLine 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuBoards 
      Caption         =   "&Boards"
      Begin VB.Menu mnuAddNew 
         Caption         =   "&Add new"
         Begin VB.Menu mnuEmpty 
            Caption         =   "Empty"
            Shortcut        =   ^E
         End
         Begin VB.Menu mnuRandom 
            Caption         =   "Random"
            Shortcut        =   ^R
         End
      End
      Begin VB.Menu mnuCheck 
         Caption         =   "Check"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuClearAll 
         Caption         =   "Clear all"
      End
   End
   Begin VB.Menu mnuAbout 
      Caption         =   "&About"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Utilized to allow the use of XP-theme
Private Declare Sub InitCommonControls Lib "comctl32" ()

' De ulike brettene
Public Boards As New Collection

' Used to show the different dialogs
Public OpenSave As New clsCommonDialogs

Public Sub UpdateControls()
    
    On Error Resume Next
    Dim Tell As Long, iWidth As Long

    ' Firstly, kill all boards that aren't needed
    For Tell = usrBoard.LBound + 1 To usrBoard.UBound
        Unload usrBoard(Tell)
    Next
    
    ' Hide changes
    picContainer.Visible = False
    
    ' Hide the first board
    usrBoard(0).Visible = False

    ' Appends all the boards to the container
    For Tell = usrBoard.LBound To Boards.Count - 1
    
        ' Load the control if needed
        If Tell > usrBoard.LBound Then
            Load usrBoard(Tell)
        End If
    
        ' Initialize the board
        Set usrBoard(Tell).Board = Boards(Tell + 1 + (vScroll.Value * 3))
        
        ' Make sure the control exitst
        If Not (usrBoard(Tell).Board Is Nothing) Then
        
            ' Update its content
            usrBoard(Tell).Update
            
            ' Set the caption
            usrBoard(Tell).Caption = "Brett " & Tell + 1 + (vScroll.Value * 3)
            usrBoard(Tell).Visible = True
            
        End If
        
        ' Set its position
        usrBoard(Tell).Left = usrBoard(Tell - 1).Left + usrBoard(Tell).Width
        usrBoard(Tell).Top = usrBoard(Tell - 1).Top
        
        ' See if we have to move the board downwards
        If usrBoard(Tell).Left + usrBoard(Tell).Width > picContainer.Width Then
            
            usrBoard(Tell).Top = usrBoard(Tell).Top + usrBoard(Tell).Height
            usrBoard(Tell).Left = usrBoard(usrBoard.LBound).Left
            
            ' This elements index is equal to the maximum amount of boards in the width
            If iWidth = 0 Then
                iWidth = Tell
            End If
        
        End If
        
        ' Save the top-value
        usrBoard(Tell).Tag = usrBoard(Tell).Top
    
        ' If we've reached the end, stop adding boards
        If usrBoard(Tell).Tag > picContainer.Height Then
            Unload usrBoard(Tell)
            Exit For
        End If
    
    Next
    
    ' Calculate the amount of elements that aren't seen, thus updating the scrollbar
    vScroll.Max = RoundUp((Boards.Count - usrBoard.Count) / iWidth)
    
    ' See if we really need it
    If iWidth = 0 Then
        vScroll.Visible = False
    Else
        vScroll.Visible = (vScroll.Max > 0)
    End If

    ' Show the picture box again
    picContainer.Visible = True

End Sub

Private Function RoundUp(Value As Double) As Long

    ' Round up if non-integer
    If Value <> Fix(Value) Then
        RoundUp = Fix(Value) + 1
    Else
        RoundUp = Value
    End If

End Function

Private Sub Form_Initialize()
    
    ' Allows XP-theme
    InitCommonControls

    ' Set the filters
    OpenSave.Filter = "Data-files (*.dat)" & Chr(0) & "*.dat"

End Sub

Private Sub Form_Resize()

    ' Resize controls
    picContainer.Width = Me.ScaleWidth - 16
    picContainer.Height = Me.ScaleHeight - 16
    vScroll.Left = picContainer.Width - vScroll.Width - 4
    vScroll.Height = picContainer.Height - 4
    
    ' Update controls
    UpdateControls

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Dim Form As Form

    ' Unload all forms
    For Each Form In Forms
        Unload Form
    Next

End Sub

Private Sub mnuAbout_Click()

    ' Inform who's the author
    MsgBox "Made by " & App.LegalCopyright & ", version " & App.Major & "." & App.Minor & "." & App.Revision, vbInformation

End Sub

Private Sub mnuCheck_Click()

    ' Reference the boards
    Set frmCheck.Boards = Boards

    ' Show the check-dialog
    frmCheck.Show

End Sub

Private Sub mnuClearAll_Click()

    ' Remove everything
    Set Boards = New Collection
    
    ' Update controls
    UpdateControls

End Sub

Private Sub mnuEmpty_Click()

    Dim oEmpty As New clsBoard

    ' Allocate the array
    oEmpty.AllocateNumbers 24
    
    ' Add a new, empty board to the collection
    Boards.Add oEmpty
    
    ' Update all controls
    UpdateControls
    
End Sub

Private Sub mnuExit_Click()

    ' Exit the application
    Unload Me

End Sub

Private Sub mnuOpen_Click()

    ' Show the open dialog
    OpenSave.ShowOpen Me.hWnd, "Open file"
    
    ' See whether or not a file was selected
    If OpenSave.File <> "" Then
    
        ' Open this file
        OpenFile OpenSave.File
    
    End If

End Sub

Public Sub OpenFile(sFile As String)

    Dim Free As Long, BoardCount As Long, Tell As Long
    
    ' Get a new, fresh collection of boards
    Set Boards = New Collection
    
    ' Retrieve a free handle
    Free = FreeFile

    ' First, open this file
    Open sFile For Binary As #Free
    
        ' Retrieve the amount of boards
        Get #Free, , BoardCount
        
        ' Add all these boards
        For Tell = 1 To BoardCount
            
            ' Add a new board
            Boards.Add New clsBoard
            
            ' Load it from the file
            Boards(Tell).FileLoad Free
        
        Next
    
    ' Close the given file
    Close #Free

    ' Update the controls
    UpdateControls

End Sub

Public Sub SaveFile(sFile As String)

    Dim Free As Long, Tell As Long
    
    ' If the file already exist, we'll have to delete it
    If Dir(sFile) <> "" Then
        Kill sFile
    End If
    
    ' Retrieve a free handle
    Free = FreeFile

    ' First, open this file
    Open sFile For Binary As #Free
    
        ' Put the amount of boards
        Put #Free, , Boards.Count
        
        ' Add all these boards
        For Tell = 1 To Boards.Count
            
            ' Save it to the file
            Boards(Tell).FileSave Free
        
        Next
    
    ' Close the given file
    Close #Free

End Sub

Private Sub mnuRandom_Click()

    Dim oEmpty As New clsBoard, Tell As Long, Value As Long, Temp As Long, bPresent As Boolean

    ' Initialize randomizer
    Randomize

    ' Allocate the array
    For Tell = 1 To 25
        
        ' Initialize variables
        bPresent = True
        
        ' Calculate a unique value
        Do While bPresent
            
            ' Find a random value
            Value = Rnd * 99
            
            ' Reset variables
            bPresent = (oEmpty.FindNumber(Value, 0, Tell - 1) >= 0)
            
        Loop
        
        ' Add the number
        oEmpty.AppendNumber Value, vbWhite
    Next
    
    ' Add a new, empty board to the collection
    Boards.Add oEmpty
    
    ' Update all controls
    UpdateControls

End Sub

Private Sub mnuSave_Click()

    ' Show the save dialog
    OpenSave.ShowSave Me.hWnd, "Save file"
    
    ' See whether or not a file was selected
    If OpenSave.File <> "" Then
    
        ' Save this file
        SaveFile OpenSave.File
    
    End If

End Sub

Private Sub usrBoard_DeleteBoard(Index As Integer)

    ' Firstly, remove the board from the index
    Boards.Remove Index + 1
    
    ' Then redraw the boards
    UpdateControls

End Sub

Private Sub vScroll_Change()

    ' Update the controls
    UpdateControls

End Sub

Private Sub vScroll_Scroll()

    ' Move controls
    vScroll_Change

End Sub
